using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;

namespace IO
{
    /// <summary>
    ///  _tH[}bg
    /// </summary>
    [Flags]
    public enum VertexFlag : int
    {
        POSITION = 0,
        UVx1 = 1, UVx2 = 2, UVx3 = 3,
        UVMask = 7, UVShift = 0,
        WTx1 = 8, WTx2 = 16, WTx3 = 17,
        WTMask = 56, WTShift = 3,
        TANGENT = 256,
        NORMAL = 512,
        BINORMAL = 1024,
    }

    /// <summary>
    /// ėpbV[_[
    /// </summary>
    public interface IMeshLoader
    {
        int getTriangleCount();
        IEnumerable<int[]> getTriangles();
        IEnumerable<int[]> getSeparatedTriangles();

        int getVertexCount();
        int getSeparatedVertexCount();

        int getFaceCount();
        int[] getFacePointArray(int faceNo);

        float getSmoothingAngle();

        Vector3 getPosition(int vertexNo);
        Vector2 getTextureCoord(int faceNo, int apexNo);
        Vector3 getNormal(int faceNo, int apexNo);
        Vector3 getTangent(int faceNo, int apexNo);
        Vector3 getBinormal(int faceNo, int apexNo);
        Vector4[] getWeights(int faceNo, int apexNo);
        int getMaterialIndex(int faceNo);

        VertexFlag getIdealVertexFormat();
    }
}
